Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/Vision.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/Vision.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/AdvancedAta/Vision.asm	(revision 589)
@@ -29,5 +29,5 @@
 ;		AX:		ID WORD specific for QDI Vision Controllers
 ;				(AL = QD65xx Config Register contents)
-;				(AH = QDI Vision Controller ID (bits 4...7))
+;				(AH = QDI Vision Controller ID)
 ;		DX:		Controller port (not IDE port)
 ;		ZF:		Set if controller found
@@ -46,8 +46,8 @@
 	; from Axh to Bxh.
 	call	IsConfigRegisterWithIDinAL
-	je		SHORT VisionControllerDetected
+	je		SHORT VisionControllerDetected.Return
 
 	; Check QD65xx alternative base port
-	or		dl, QD65XX_ALTERNATIVE_BASE_PORT
+	mov		dl, QD65XX_ALTERNATIVE_BASE_PORT
 	in		al, QD65XX_ALTERNATIVE_BASE_PORT + QD65XX_CONFIG_REGISTER_in
 %endif ; DANGEROUS_DETECTION
@@ -68,11 +68,12 @@
 	mov		ah, al
 	and		al, MASK_QDCONFIG_CONTROLLER_ID
-	cmp		al, ID_QD6500 << 4
+	cmp		al, ID_QD6500
 	je		SHORT VisionControllerDetected
-	cmp		al, ID_QD6580 << 4
+	cmp		al, ID_QD6580
 	je		SHORT VisionControllerDetected
-	cmp		al, ID_QD6580_ALTERNATE << 4
+	cmp		al, ID_QD6580_ALTERNATE
 VisionControllerDetected:
 	xchg	ah, al
+.Return:
 	ret
 
@@ -82,5 +83,5 @@
 ;	Parameters:
 ;		AL:		QD65xx Config Register contents
-;		AH:		QDI Vision Controller ID (bits 4...7)
+;		AH:		QDI Vision Controller ID
 ;		BX:		IDE Base port to check
 ;		DX:		Vision Controller port
@@ -92,5 +93,5 @@
 ;--------------------------------------------------------------------
 Vision_DoesIdePortInBXbelongToControllerWithIDinAX:
-	cmp		ah, ID_QD6500 << 4
+	cmp		ah, ID_QD6500
 	je		SHORT .DoesIdePortInDXbelongToQD6500
 
@@ -128,5 +129,5 @@
 ;	Parameters:
 ;		AL:		QD65xx Config Register contents
-;		AH:		QDI Vision Controller ID (bits 4...7)
+;		AH:		QDI Vision Controller ID
 ;	Returns:
 ;		AL:		Max supported PIO mode
@@ -139,5 +140,5 @@
 ;--------------------------------------------------------------------
 Vision_GetMaxPioModeToALandMinCycleTimeToBX:
-	cmp		ah, ID_QD6500 << 4
+	cmp		ah, ID_QD6500
 	jne		SHORT .NoNeedToLimitForQD6580
 
@@ -149,8 +150,7 @@
 
 ;--------------------------------------------------------------------
-; Vision_InitializeWithIDinAHandConfigInAL
-;	Parameters:
-;		AL:		QD65xx Config Register contents
-;		AH:		QDI Vision Controller ID (bits 4...7)
+; Vision_InitializeWithIDinAH
+;	Parameters:
+;		AH:		QDI Vision Controller ID
 ;		DS:DI:	Ptr to DPT for Single or Slave Drive
 ;		SI:		Offset to Master DPT if Slave Drive present
@@ -162,7 +162,7 @@
 ;		AX, BX, CX, DX, BP
 ;--------------------------------------------------------------------
-Vision_InitializeWithIDinAHandConfigInAL:
+Vision_InitializeWithIDinAH:
 	; QD6580 has a Control Register that needs to be programmed
-	cmp		ah, ID_QD6500 << 4
+	cmp		ah, ID_QD6500
 	mov		dx, [di+DPT_ADVANCED_ATA.wControllerBasePort]
 	mov		bp, QD6500_MAX_ACTIVE_TIME_CLOCKS | (QD6500_MIN_ACTIVE_TIME_CLOCKS << 8)	; Assume QD6500
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectDrives.asm	(revision 589)
@@ -81,5 +81,5 @@
 	mov		al, [cs:ROMVARS.wFlags]			; Configurator set to always scan?
 	or		al, [es:BDA.bKBFlgs1]			; Or, did the user hold down the ALT key?
-	and		al, 8							; 8 = alt key depressed, same as FLG_ROMVARS_SERIAL_ALWAYSDETECT
+	and		al, 8							; 8 = alt key depressed, same as FLG_ROMVARS_SERIAL_SCANDETECT
 	jnz		.DriveDetectLoop
 %endif ; MODULE_SERIAL
@@ -135,5 +135,5 @@
 
 	shr		ch, 1							; number of drives, 1 or 2 only, to CF flag (clear=1, set=2)
-	rcl		al, 1							; starting drive number in upper 7 bits, number of drives in low bit
+	eRCL_IM	al, 1							; starting drive number in upper 7 bits, number of drives in low bit
 .NoFloppies:
 	mov		[RAMVARS.xlateVars+XLATEVARS.bFlopCntAndFirst], al
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 589)
@@ -90,6 +90,5 @@
 %ifdef MODULE_SERIAL
 	cmp		dh, DEVICE_SERIAL_PORT			; Check if this is a serial device
-
-	jnz		.pushAndPrint					; CX = string to print, AX = port address, DX won't be used
+	jne		SHORT .pushAndPrint				; CX = string to print, AX = port address, DX won't be used
 
 	mov		cl, (g_szDetectCOM-$$) & 0xff	; Setup print string for COM ports
@@ -106,21 +105,21 @@
 
 	test	dl, dl							; Check if serial port "Auto"
-	jz		.pushAndPrintSerial				; CX = string to print, AX and DX won't be used
+	jz		SHORT .pushAndPrintSerial		; CX = string to print, AX and DX won't be used
 
 	mov		cl, (g_szDetectCOMLarge-$$) & 0xff	; Setup secondary print string for "COMn/xx.yK"
 
-	mov		al,ah							; baud rate divisor to AL
+	mov		al, ah							; baud rate divisor to AL
 	cbw										; clear AH, AL will always be less than 128
-	xchg	si,ax							; move AX to SI for divide
-	mov		ax,1152							; baud rate to display is 115200/divisor, the "00" is handled
+	xchg	si, ax							; move AX to SI for divide
+	mov		ax, 1152						; baud rate to display is 115200/divisor, the "00" is handled
 											; in the print strings
 	cwd										; clear top 16-bits of dividend
 	div		si								; and divide...  Now AX = baud rate/100, DX = 0 (always a clean divide)
 
-	mov		si,10							; Now separate the whole portion from the fractional for "K" display
+	mov		si, 10							; Now separate the whole portion from the fractional for "K" display
 	div		si								; and divide...  Now AX = baud rate/1000, DX = low order digit
 
-	cmp		ax,si							; < 10: "2400", "9600", etc.; >= 10: "19.2K", "38.4K", etc.
-	jae		.pushAndPrintSerial
+	cmp		ax, si							; < 10: "2400", "9600", etc.; >= 10: "19.2K", "38.4K", etc.
+	jae		SHORT .pushAndPrintSerial
 
 	mov		cl, (g_szDetectCOMSmall-$$) & 0xff	; Setup secondary print string for "COMn/XXy00"
@@ -150,8 +149,8 @@
 DetectPrint_DriveNameFromDrvDetectInfoInESBX:
 	push	bp
-	mov		bp,sp
-	lea		si,[bx+DRVDETECTINFO.szDrvName]
+	mov		bp, sp
+	lea		si, [bx+DRVDETECTINFO.szDrvName]
 	push	si
-	mov		si,g_szDriveName
+	mov		si, g_szDriveName
 	jmp		SHORT DetectPrint_FormatCSSIfromParamsInSSBP
 
@@ -276,5 +275,5 @@
 ;
 	push	bp
-	mov		bp,sp
+	mov		bp, sp
 	; Fall to DetectPrint_FormatCSSIfromParamsInSSBP
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/Interrupts.asm	(revision 589)
@@ -240,7 +240,6 @@
 	push	cx
 	xchg	ax, cx				; IRQ index to CL
-	mov		ch, 1				; Load 1 to be shifted
-	shl		ch, cl				; Shift bit to correct position
-	not		ch					; Invert to create bit mask for clearing
+	mov		ch, ~1				; Load bit mask to be rotated
+	rol		ch, cl				; Rotate mask to correct position for clearing
 	in		al, dx				; Read Interrupt Mask Register
 	and		al, ch				; Clear wanted bit
Index: /trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 589)
@@ -117,5 +117,5 @@
 
 %ifdef MODULE_SERIAL
-	at	ROMVARS.ideVarsSerialAuto+IDEVARS.bDevice,		db	DEVICE_SERIAL_PORT
+	at	ROMVARS.ideVarsSerialAuto+IDEVARS.bDevice,	db	DEVICE_SERIAL_PORT
 %endif
 %else
@@ -134,26 +134,39 @@
 	at	ROMVARS.bIdleTimeout,	db	0						; Standby timer disabled by default
 
-%ifdef MODULE_8BIT_IDE_ADVANCED
-	at	ROMVARS.ideVars0+IDEVARS.wBasePort,				dw	DEVICE_XTIDE_DEFAULT_PORT		; Controller Command Block base port
-	at	ROMVARS.ideVars0+IDEVARS.bDevice,				db	DEVICE_8BIT_XTCF_PIO8
+%ifndef MODULE_8BIT_IDE
+	at	ROMVARS.ideVars0+IDEVARS.wBasePort,			dw	DEVICE_ATA_PRIMARY_PORT 		; Controller Command Block base port
+	at	ROMVARS.ideVars0+IDEVARS.wControlBlockPort,	dw	DEVICE_ATA_PRIMARY_PORTCTRL 	; Controller Control Block base port
+	at	ROMVARS.ideVars0+IDEVARS.bDevice,			db	DEVICE_16BIT_ATA
+%elifdef MODULE_8BIT_IDE_ADVANCED
+	at	ROMVARS.ideVars0+IDEVARS.wBasePort,			dw	DEVICE_XTIDE_DEFAULT_PORT		; Controller Command Block base port
+	at	ROMVARS.ideVars0+IDEVARS.bDevice,			db	DEVICE_8BIT_XTCF_PIO8
 %else
-	at	ROMVARS.ideVars0+IDEVARS.wBasePort,				dw	DEVICE_XTIDE_DEFAULT_PORT		; Controller Command Block base port
-	at	ROMVARS.ideVars0+IDEVARS.wControlBlockPort,		dw	DEVICE_XTIDE_DEFAULT_PORTCTRL	; Controller Control Block base port
-	at	ROMVARS.ideVars0+IDEVARS.bDevice,				db	DEVICE_8BIT_XTIDE_REV1
+	at	ROMVARS.ideVars0+IDEVARS.wBasePort,			dw	DEVICE_XTIDE_DEFAULT_PORT		; Controller Command Block base port
+	at	ROMVARS.ideVars0+IDEVARS.wControlBlockPort,	dw	DEVICE_XTIDE_DEFAULT_PORTCTRL	; Controller Control Block base port
+	at	ROMVARS.ideVars0+IDEVARS.bDevice,			db	DEVICE_8BIT_XTIDE_REV1
 %endif
 	at	ROMVARS.ideVars0+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 	at	ROMVARS.ideVars0+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 
+	at	ROMVARS.ideVars1+IDEVARS.wBasePort,			dw	DEVICE_ATA_SECONDARY_PORT
+	at	ROMVARS.ideVars1+IDEVARS.wControlBlockPort,	dw	DEVICE_ATA_SECONDARY_PORTCTRL
+	at	ROMVARS.ideVars1+IDEVARS.bDevice,			db	DEVICE_16BIT_ATA
 	at	ROMVARS.ideVars1+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 	at	ROMVARS.ideVars1+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 
+	at	ROMVARS.ideVars2+IDEVARS.wBasePort,			dw	DEVICE_ATA_TERTIARY_PORT
+	at	ROMVARS.ideVars2+IDEVARS.wControlBlockPort,	dw	DEVICE_ATA_TERTIARY_PORTCTRL
+	at	ROMVARS.ideVars2+IDEVARS.bDevice,			db	DEVICE_16BIT_ATA
 	at	ROMVARS.ideVars2+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 	at	ROMVARS.ideVars2+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 
+	at	ROMVARS.ideVars3+IDEVARS.wBasePort,			dw	DEVICE_ATA_QUATERNARY_PORT
+	at	ROMVARS.ideVars3+IDEVARS.wControlBlockPort,	dw	DEVICE_ATA_QUATERNARY_PORTCTRL
+	at	ROMVARS.ideVars3+IDEVARS.bDevice,			db	DEVICE_16BIT_ATA
 	at	ROMVARS.ideVars3+IDEVARS.drvParamsMaster+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 	at	ROMVARS.ideVars3+IDEVARS.drvParamsSlave+DRVPARAMS.wFlags,	db	DISABLE_WRITE_CACHE | FLG_DRVPARAMS_BLOCKMODE | (TRANSLATEMODE_AUTO<<TRANSLATEMODE_FIELD_POSITION)
 
 %ifdef MODULE_SERIAL
-	at	ROMVARS.ideVarsSerialAuto+IDEVARS.bDevice,		db	DEVICE_SERIAL_PORT
+	at	ROMVARS.ideVarsSerialAuto+IDEVARS.bDevice,	db	DEVICE_SERIAL_PORT
 %endif
 %endif
@@ -286,2 +299,15 @@
 	%include "AH41h_CheckIfExtensionsPresent.asm"
 %endif
+
+
+; Although it's very unlikely to happen, we give warnings for builds that cannot be automatically checksummed due to the size being too large.
+; In some cases it's theoretically possible to checksum the build anyway (manually) which is why these are warnings and not errors.
+%if BIOS_SIZE = 8192				; A small build, possibly a candidate for the ROM socket on a 3Com 3C503 card.
+	%if ($-$$) <= BIOS_SIZE			; Only give warnings when the problem isn't obvious anyway.
+		%if ($-$$) > BIOS_SIZE - 3
+			%warning "This build is too large to be auto-checksummed!"
+		%endif
+	%endif
+%elif ($-$$) = BIOS_SIZE			; A large build.
+	%warning "This build is too large to be auto-checksummed!"
+%endif
Index: /trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrint.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrint.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Menus/BootMenu/BootMenuPrint.asm	(revision 589)
@@ -39,20 +39,20 @@
 	mov		si, g_szRomBootDash						; Standard "Rom Boot" but with a "-" at the front
 	mov		al, 20h									; The space between "Rom" and "Boot"
-	jnc		.ROMBoot								; display "Rom Boot" option for last entry
+	jnc		SHORT .ROMBoot							; display "Rom Boot" option for last entry
 
 	call	FindDPT_ForDriveNumberInDL
-	jc		.notOurs
+	jc		SHORT .notOurs
 
 	call	DriveDetectInfo_ConvertDPTtoBX
 	mov		si, g_szDriveNumBOOTNFO					; special g_szDriveNum that prints from BDA
-	jmp		.go
+	jmp		SHORT .go
 
 .notOurs:
-	mov		si,g_szDriveNum
-	mov		bx,g_szForeignHD						; assume a hard disk for the moment
+	mov		si, g_szDriveNum
+	mov		bx, g_szForeignHD						; assume a hard disk for the moment
 
 	test	dl, dl
-	js		.go
-	mov		bl,((g_szFloppyDrv)-$$ & 0xff)			; and revisit the earlier assumption...
+	js		SHORT .go
+	mov		bl, ((g_szFloppyDrv)-$$ & 0xff)			; and revisit the earlier assumption...
 
 .go:
@@ -60,8 +60,6 @@
 	call	DriveXlate_ToOrBack
 
-	test	dl, 0f0h								; if there is a character in the upper nibble
-	jnz		.noSpace
-	dec		si										; backup a character to a leading space
-.noSpace:
+	cmp		dl, 10h									; Check if there is a character in the upper nibble
+	sbb		si, 0									; If not, backup a character to a leading space
 
 	push	dx										; translated drive number
@@ -86,5 +84,5 @@
 ;--------------------------------------------------------------------
 BootMenuPrint_TitleStrings:
-	xor		di,di						; Null character will be eaten
+	xor		di, di						; Null character will be eaten
 	mov		si, g_szBootMenuTitle
 	jmp		DetectPrint_RomFoundAtSegment.BootMenuEntry
@@ -105,5 +103,5 @@
 
 	call	BootMenu_GetDriveToDXforMenuitemInCX
-	jnc		BootMenuEvent_Completed						; nothing to display if "Rom Boot" option
+	jnc		SHORT BootMenuEvent_Completed				; nothing to display if "Rom Boot" option
 
 	push	bp
@@ -116,9 +114,9 @@
 	inc		dl											; are we a hard disk?
 	dec		dl											; inc/dec will set SF, without modifying CF or DL
-	js		.HardDiskRefreshInformation
-
-	jnc		.ours										; Based on CF from FindDPT_ForDriveNumberInDL above
+	js		SHORT .HardDiskRefreshInformation
+
+	jnc		SHORT .ours									; Based on CF from FindDPT_ForDriveNumberInDL above
 	call	FloppyDrive_GetType							; Get Floppy Drive type to BX
-	jmp		.around
+	jmp		SHORT .around
 .ours:
 	call	AH8h_GetDriveParameters
@@ -132,5 +130,4 @@
 	cmp		bl, FLOPPY_TYPE_35_ED
 	ja		SHORT .PushAXAndOutput
-
 	; Fall to .PrintKnownFloppyType
 
@@ -162,5 +159,5 @@
 	mov		al, (g_szFddThreeHalf - $$) & 0xff
 	cmp		bl, FLOPPY_TYPE_525_HD
-	ja		.ThreeHalf
+	ja		SHORT .ThreeHalf
 	mov		al, (g_szFddFiveQuarter - $$) & 0xff
 .ThreeHalf:
@@ -168,5 +165,5 @@
 
 	xor		bh, bh
-	mov		al,FloppyTypes.rgbCapacityMultiplier
+	mov		al, FloppyTypes.rgbCapacityMultiplier
 	mul		BYTE [cs:bx+FloppyTypes.rgbCapacity - 1]	; -1 since 0 is handled above and not in the table
 
@@ -184,16 +181,35 @@
 ;	Parameters:
 ;		DS:		RAMVARS segment
+;		DI:		Zero if foreign drive
+;				Offset to DPT if our drive
+;		CF:		Set if foreign drive
+;				Clear if our drive
 ;	Returns:
 ;		CF:		Set since menu event was handled successfully
 ;	Corrupts registers:
-;		BX, CX, DX, SI, DI, ES
+;		AX, BX, CX, DX, SI, DI, ES
 ;--------------------------------------------------------------------
 .HardDiskRefreshInformation:
-	jc		.HardDiskMenuitemInfoForForeignDrive		; Based on CF from FindDPT_ForDriveNumberInDL (way) above
+	jc		SHORT .HardDiskMenuitemInfoForForeignDrive	; Based on CF from FindDPT_ForDriveNumberInDL (way) above
 
 .HardDiskMenuitemInfoForOurDrive:
 	ePUSH_T ax, g_szInformation							; Add substring for our hard disk information
-	call	GetTotalSectorCount
-	jmp		.ConvertSectorCountInBXDXAXtoSizeAndPushForFormat
+
+%ifdef MODULE_EBIOS
+	ePUSH_T ax, .ConvertSectorCountInBXDXAXtoSizeAndPushForFormat
+	test	BYTE [di+DPT.bFlagsLow], FLGL_DPT_LBA
+%ifdef USE_386
+	jnz		AccessDPT_GetLbaSectorCountToBXDXAX
+	jmp		AH15h_GetSectorCountToBXDXAX
+%else ; ~USE_386
+	jz		SHORT .NoLBA
+	jmp		AccessDPT_GetLbaSectorCountToBXDXAX
+.NoLBA:
+	jmp		AH15h_GetSectorCountToBXDXAX
+%endif
+%else ; ~MODULE_EBIOS
+	call	AH15h_GetSectorCountToBXDXAX
+	jmp		SHORT .ConvertSectorCountInBXDXAXtoSizeAndPushForFormat
+%endif ; MODULE_EBIOS
 
 .HardDiskMenuitemInfoForForeignDrive:
@@ -226,18 +242,2 @@
 	db		2880  / FloppyTypes.rgbCapacityMultiplier    ;  type 5
 	db		2880  / FloppyTypes.rgbCapacityMultiplier    ;  type 6
-
-
-;--------------------------------------------------------------------
-; GetTotalSectorCount
-;	Parameters:
-;		DS:DI:		DPT Pointer
-;	Returns:
-;		BX:DX:AX:	48-bit sector count
-;	Corrupts registers:
-;		CX
-;--------------------------------------------------------------------
-%ifdef MODULE_EBIOS
-GetTotalSectorCount		EQU		AccessDPT_GetLbaSectorCountToBXDXAX
-%else
-GetTotalSectorCount		EQU		AH15h_GetSectorCountToBXDXAX
-%endif
Index: /trunk/XTIDE_Universal_BIOS/Src/Strings.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 589)
@@ -136,8 +136,11 @@
 g_szDeviceTypeValues:
 g_szDeviceTypeValues_16bit:			db	" 16",NULL
+%ifdef MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
 g_szDeviceTypeValues_32bit:			db	" 32",NULL
+%ifdef MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
 g_szDeviceTypeValues_8bit:			db	"  8",NULL
 g_szDeviceTypeValues_XTIDEr1:		db	"D8 ",NULL	; Dual 8-bit
 g_szDeviceTypeValues_XTIDEr2:		db	"X8 ",NULL	; A0<->A3 swapped 8-bit
+%ifdef MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
 g_szDeviceTypeValues_XTCFpio8:		db	"T8 ",NULL	; True 8-bit
 g_szDeviceTypeValues_XTCFpio8BIU:	db	"T8B",NULL
@@ -146,7 +149,13 @@
 g_szDeviceTypeValues_JrIde:			db	"M8 ",NULL	; Memory Mapped 8-bit
 g_szDeviceTypeValues_ADP50L:		db	"M8 ",NULL	; Memory Mapped 8-bit
+%ifdef MODULE_SERIAL
 g_szDeviceTypeValues_Serial:		db	"SER",NULL
-
-g_szDeviceTypeValues_Displacement equ (g_szDeviceTypeValues_32bit - g_szDeviceTypeValues)
+%endif ; MODULE_SERIAL
+%endif ; MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+%endif ; MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+%endif ; MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
+g_szDeviceTypeValues_Displacement equ 3		; 3 compressed, 4 uncompressed
+;g_szDeviceTypeValues_Displacement equ (g_szDeviceTypeValues_32bit - g_szDeviceTypeValues)
 ;
 ; Ensure that device type strings are correctly spaced in memory
@@ -156,7 +165,13 @@
 		%error "g_szDeviceTypeValues Displacement Incorrect 1"
 	%endif
+
+	%ifdef MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 	%if g_szDeviceTypeValues_32bit <> g_szDeviceTypeValues_16bit + g_szDeviceTypeValues_Displacement
 		%error "g_szDeviceTypeValues Displacement Incorrect 2"
 	%endif
+
+	%ifdef MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 	%if g_szDeviceTypeValues_8bit <> g_szDeviceTypeValues_32bit + g_szDeviceTypeValues_Displacement
 		%error "g_szDeviceTypeValues Displacement Incorrect 3"
@@ -168,4 +183,7 @@
 		%error "g_szDeviceTypeValues Displacement Incorrect 5"
 	%endif
+
+	%ifdef MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 	%if g_szDeviceTypeValues_XTCFpio8 <> g_szDeviceTypeValues_XTIDEr2 + g_szDeviceTypeValues_Displacement
 		%error "g_szDeviceTypeValues Displacement Incorrect 6"
@@ -186,7 +204,16 @@
 		%error "g_szDeviceTypeValues Displacement Incorrect 11"
 	%endif
+
+	%ifdef MODULE_SERIAL
+
 	%if g_szDeviceTypeValues_Serial <> g_szDeviceTypeValues_ADP50L + g_szDeviceTypeValues_Displacement
 		%error "g_szDeviceTypeValues Displacement Incorrect 12"
 	%endif
+
+	%endif ; MODULE_SERIAL
+	%endif ; MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+	%endif ; MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+	%endif ; MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm	(revision 589)
@@ -257,8 +257,10 @@
                            			  db	 20h,  2bh,  0fh          ; compressed
 
+%ifdef MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
 g_szDeviceTypeValues_32bit:			; db	" 32",NULL
                            			; db	 20h,  33h,  32h,  00h    ; uncompressed
                            			  db	 20h,  2dh,  0ch          ; compressed
 
+%ifdef MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
 g_szDeviceTypeValues_8bit:			; db	"  8",NULL
                           			; db	 20h,  20h,  38h,  00h    ; uncompressed
@@ -273,4 +275,5 @@
                              		  db	 5eh,  30h,  00h          ; compressed
 
+%ifdef MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
 g_szDeviceTypeValues_XTCFpio8:		; db	"T8 ",NULL	; True 8-bit
                               		; db	 54h,  38h,  20h,  00h    ; uncompressed
@@ -297,10 +300,16 @@
                             		  db	 53h,  30h,  00h          ; compressed
 
+%ifdef MODULE_SERIAL
 g_szDeviceTypeValues_Serial:		; db	"SER",NULL
                             		; db	 53h,  45h,  52h,  00h    ; uncompressed
                             		  db	 59h,  4bh,  98h          ; compressed
 
-
-g_szDeviceTypeValues_Displacement equ (g_szDeviceTypeValues_32bit - g_szDeviceTypeValues)
+%endif ; MODULE_SERIAL
+%endif ; MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+%endif ; MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+%endif ; MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
+g_szDeviceTypeValues_Displacement equ 3		; 3 compressed, 4 uncompressed
+;g_szDeviceTypeValues_Displacement equ (g_szDeviceTypeValues_32bit - g_szDeviceTypeValues)
 ;
 ; Ensure that device type strings are correctly spaced in memory
@@ -310,7 +319,13 @@
 %error "g_szDeviceTypeValues Displacement Incorrect 1"
 %endif
+
+%ifdef MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 %if g_szDeviceTypeValues_32bit <> g_szDeviceTypeValues_16bit + g_szDeviceTypeValues_Displacement
 %error "g_szDeviceTypeValues Displacement Incorrect 2"
 %endif
+
+%ifdef MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 %if g_szDeviceTypeValues_8bit <> g_szDeviceTypeValues_32bit + g_szDeviceTypeValues_Displacement
 %error "g_szDeviceTypeValues Displacement Incorrect 3"
@@ -322,4 +337,7 @@
 %error "g_szDeviceTypeValues Displacement Incorrect 5"
 %endif
+
+%ifdef MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 %if g_szDeviceTypeValues_XTCFpio8 <> g_szDeviceTypeValues_XTIDEr2 + g_szDeviceTypeValues_Displacement
 %error "g_szDeviceTypeValues Displacement Incorrect 6"
@@ -340,7 +358,16 @@
 %error "g_szDeviceTypeValues Displacement Incorrect 11"
 %endif
+
+%ifdef MODULE_SERIAL
+
 %if g_szDeviceTypeValues_Serial <> g_szDeviceTypeValues_ADP50L + g_szDeviceTypeValues_Displacement
 %error "g_szDeviceTypeValues Displacement Incorrect 12"
 %endif
+
+%endif ; MODULE_SERIAL
+%endif ; MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+%endif ; MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+%endif ; MODULE_ADVANCED_ATA OR MODULE_8BIT_IDE OR MODULE_8BIT_IDE_ADVANCED OR MODULE_SERIAL
+
 %endif
 
@@ -567,38 +594,38 @@
 
 ;; translated usage stats
-;; 172:2
-;; 47:2
-;; 171:2
-;; 46:3
-;; 48:2
-;; 181:1
-;; 200:1
-;; 54:2
-;; 45:2
-;; 49:2
 ;; 34:3
 ;; 179:8
-;; 56:8
+;; 46:3
+;; 44:1
+;; 200:1
+;; 48:2
+;; 175:1
+;; 171:2
+;; 51:3
+;; 50:2
 ;; 33:1
 ;; 53:2
+;; 45:2
+;; 47:2
+;; 172:2
+;; 56:8
 ;; 32:34
-;; 175:1
-;; 44:1
-;; 50:2
-;; 51:3
+;; 181:1
+;; 54:2
+;; 49:2
 ;; total translated: 20
 
 ;; format usage stats
-;; z:2
+;; 5-x:1
+;; 2-u:1
+;; s:14
 ;; nl:12
-;; u:6
-;; 5-x:1
-;; c:13
 ;; A:4
-;; s:14
 ;; 5-u:2
 ;; x:5
-;; 2-u:1
 ;; 2-I:1
+;; z:2
+;; u:6
+;; c:13
 ;; total format: 11
 
Index: /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/AccessDPT.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/AccessDPT.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/AccessDPT.asm	(revision 589)
@@ -62,5 +62,5 @@
 
 	jnz		SHORT .EnableDeviceIrq
-	or		al, FLG_DEVCONTROL_nIEN	; Disable IRQ
+	mov		al, FLG_DEVCONTROL_nIEN	; Disable IRQ
 .EnableDeviceIrq:
 %else
Index: /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/CompatibleDPT.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/CompatibleDPT.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/CompatibleDPT.asm	(revision 589)
@@ -231,13 +231,15 @@
 
 	xor		dl, dl							; Clear DL for checksum
+	push	bp
+	mov		bp, StoswThenAddALandAHtoDL
 
 	; DPTE.wBasePort
 	mov		ax, [si+DPT.wBasePort]
-	call	StoswThenAddALandAHtoDL			; Bytes 0 and 1
+	call	bp								; Bytes 0 and 1
 
 	; DPTE.wControlBlockPort
 	eMOVZX	bx, [si+DPT.bIdevarsOffset]
 	mov		ax, [cs:bx+IDEVARS.wControlBlockPort]
-	call	StoswThenAddALandAHtoDL			; Bytes 2 and 3
+	call	bp								; Bytes 2 and 3
 
 	; DPTE.bDrvnhead and DPTE.bBiosVendor
@@ -245,14 +247,14 @@
 	call	AccessDPT_GetDriveSelectByteToAL
 	xchg	si, di
-	call	StoswThenAddALandAHtoDL			; Bytes 4 and 5
+	call	bp								; Bytes 4 and 5
 
 	; DPTE.bIRQ and DPTE.bBlockSize
 	mov		al, [cs:bx+IDEVARS.bIRQ]		; No way to define that we might not use IRQ
-	mov		ah, [si+DPT_ATA.bBlockSize]
-	cmp		ah, 1
-	jbe		SHORT .DoNotSetBlockModeFlag
+	mov		ah, [si+DPT_ATA.bBlockSize]		; DPT_ATA.bBlockSize must never be zero!
+	sahf									; Only block size = 1 sets CF
+	jc		SHORT .DoNotSetBlockModeFlag
 	or		cl, FLG_BLOCK_MODE_ENABLED
 .DoNotSetBlockModeFlag:
-	call	StoswThenAddALandAHtoDL			; Bytes 6 and 7
+	call	bp								; Bytes 6 and 7
 
 	; DPTE.bDmaChannelAndType and DPTE.bPioMode
@@ -266,5 +268,5 @@
 	sbb		cl, -1	; FLG_FAST_PIO_ENABLED (if .wControllerID > 0)
 .DoNotSetFastPioFlag:
-	call	StoswThenAddALandAHtoDL			; Bytes 8 and 9
+	call	bp								; Bytes 8 and 9
 %endif
 
@@ -279,5 +281,6 @@
 .NoChsTranslationOrBitShiftTranslationSet:
 	xchg	ax, cx
-	call	StoswThenAddALandAHtoDL			; Bytes 10 and 11
+	call	bp								; Bytes 10 and 11
+	pop		bp
 
 	; DPTE.wReserved (must be zero)
Index: /trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- /trunk/XTIDE_Universal_BIOS/makefile	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS/makefile	(revision 589)
@@ -18,5 +18,5 @@
 # MODULE_8BIT_IDE             Support for 8-BIT IDE cards like XTIDE                               #
 # MODULE_8BIT_IDE_ADVANCED    Support for memory mapped and DMA based cards like JRIDE and XTCF    #
-# MODULE_ADVANCED_ATA         Native support for some VLB IDE controllers                          #
+# MODULE_ADVANCED_ATA         Native support for some VLB IDE controllers (requires USE_386)       #
 # MODULE_COMPATIBLE_TABLES    Support for ill behaving software that tries to access DPT directly  #
 # MODULE_BOOT_MENU            Boot Menu for selection of drive to boot from                        #
@@ -108,5 +108,5 @@
 DEFINES_XT = $(DEFINES_COMMON) ELIMINATE_CGA_SNOW MODULE_8BIT_IDE_ADVANCED
 DEFINES_XTPLUS = $(DEFINES_XT) USE_186
-DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 MODULE_IRQ MODULE_ADVANCED_ATA MODULE_COMPATIBLE_TABLES
+DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 MODULE_IRQ MODULE_COMPATIBLE_TABLES
 
 DEFINES_XT_LARGE = $(DEFINES_XT) $(DEFINES_COMMON_LARGE)
@@ -115,5 +115,5 @@
 
 DEFINES_XT_TINY = MODULE_STRINGS_COMPRESSED MODULE_8BIT_IDE NO_ATAID_VALIDATION
-DEFINES_386_8K = $(DEFINES_AT) USE_386
+DEFINES_386_8K = $(DEFINES_AT) USE_386 MODULE_ADVANCED_ATA
 
 DEFINES_ALL_FEATURES = MODULE_8BIT_IDE MODULE_8BIT_IDE_ADVANCED MODULE_ADVANCED_ATA MODULE_EBIOS MODULE_BOOT_MENU MODULE_HOTKEYS MODULE_IRQ MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_STRINGS_COMPRESSED MODULE_POWER_MANAGEMENT MODULE_COMPATIBLE_TABLES
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 589)
@@ -214,13 +214,28 @@
 	call	Buffers_GetFileBufferToESDI
 	call	EEPROM_GetXtideUniversalBiosSizeFromESDItoDXCX
-	dec		cx				; Leave space for checksum byte
-	xor		ax, ax
-ALIGN JUMP_ALIGN
+
+; Compatibility fix for 3Com 3C503 cards where the ASIC returns 8080h as the last two bytes of the ROM.
+
+	; Assume the BIOS size is not 8K, ie generate a normal checksum.
+	dec		cx
+	mov		ax, 100h
+	cmp		cx, 8192 - 1
+	jne		SHORT .BiosSizeIsNot8K
+	; The BIOS size is 8K and therefore a potential candidate for a 3Com 3C503 card.
+	dec		cx
+	dec		cx
+	mov		ah, 3
+ALIGN JUMP_ALIGN
+.BiosSizeIsNot8K:
 .SumNextByte:
 	add		al, [es:di]
+.NextChecksumByte:
 	inc		di
 	loop	.SumNextByte
 	neg		al
 	mov		[es:di], al
+	inc		cx
+	dec		ah
+	jnz		SHORT .NextChecksumByte
 
 	pop		dx
@@ -271,19 +286,20 @@
 ;		ES:DI:	Ptr to file buffer
 ;	Corrupts registers:
-;		AX
+;		Nothing
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 Buffers_GetIdeControllerCountToCX:
-	call	Buffers_GetFileBufferToESDI
-	mov		al, [es:di+ROMVARS.bIdeCnt]
-
-	; Limit controller count for lite mode
+	xor		cx, cx
+	call	Buffers_GetFileBufferToESDI
+	or		cl, [es:di+ROMVARS.bIdeCnt]
+	jnz		SHORT .LimitControllerCountForLiteMode
+	inc		cx				; Make sure there is at least one controller
+
+.LimitControllerCountForLiteMode:
 	test	BYTE [es:di+ROMVARS.wFlags], FLG_ROMVARS_FULLMODE
 	jnz		SHORT .ReturnControllerCountInCX
-	MIN_U	al, MAX_LITE_MODE_CONTROLLERS
+	MIN_U	cl, MAX_LITE_MODE_CONTROLLERS
 
 .ReturnControllerCountInCX:
-	cbw		; A maximum of 127 controllers should be sufficient
-	xchg	cx, ax
 	ret
 
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm	(revision 589)
@@ -81,4 +81,5 @@
 	mov		cl, dl
 	eSHL_IM	ch, 1
+	eRCL_IM	dl, 1
 	ret
 
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/IdeAutodetect.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/IdeAutodetect.asm	(revision 588)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/IdeAutodetect.asm	(revision 589)
@@ -56,5 +56,5 @@
 DetectMemoryMappedDeviceFromSegmentDX:
 	; *** Try to detect JR-IDE/ISA and ADP50L (only if MODULE_8BIT_IDE_ADVANCED is present) ***
-	test	WORD [di+ROMVARS.wFlags], FLG_ROMVARS_MODULE_8BIT_IDE_ADVANCED
+	test	BYTE [di+ROMVARS.wFlags], FLG_ROMVARS_MODULE_8BIT_IDE_ADVANCED
 	stc
 	jz		SHORT .NoIdeDeviceFound
